#!/usr/bin/perl

use POSIX;
use IO::Socket;
use IO::Select;
use Socket;
use Fcntl;
use Tie::RefHash;
use Time::HiRes;

$debug = 1;                                                                
$port = 4567;


my $start = time;

$pipe_start = 100;

####################iptw ################################
#$rule_start = 1000;
#$rule_delete_comand = ("/sbin/ipfw delete ");
#@pipe_delete_comand = ("/sbin/ipfw pipe delete ");
#$add_command = "/sbin/ipfw -q ";
################################################################


###########iproute2###############################################
$rule_start = 1;
$rule_delete_comand = ("/sbin/iptables -t filter -D FORWARD ");
@pipe_delete_comand = ("/sbin/tc filter del dev eth0 parent 1:0 protocol ip prio ", "/sbin/tc class del dev eth0 parent 1:0 classid 1:");
$add_command = "";
###################################################################


$| = 1;

print "starting manad..\n";


# База данных правил клиентов
%CLRULE = ();

# База данных используемых номеров правил
%USERULEN = ();
%CLUSERULEN = ();

# База данных используемых номеров труб
%USEPIPEN = ();
%CLUSEPIPEN = ();

# Начать с пустыми буферами
%inbuffer	= ();
%outbuffer	= ();
%ready		= ();

tie %ready, 'Tie::RefHash';

# Прослушивать порт
$server = IO::Socket::INET->new( LocalPort => $port, Listen => 10 )
	or die "Can`t make server socket: $@\n";


$SIG{INT} = sub { $server->close(); exit( 0 ); };

$select = IO::Select->new( $server );

$pid = getpid();

open(FILE, ">/var/run/manad.pid");
print FILE $pid;
close(FILE);

# Устанавливаем новый root каталог для процесса
# chroot( $homedir ) or die "Couldn`t chroot to $homedir: $!\n";

# Главный цикл: проверка чтения/принятия, проверка записи,
# проверка готовности к работе

while( 1 )
{
	my $client;
	my $rv;
	my $data;

	# Проверить наличие новой информации на имеющихся подключениях

	# Есть ли что-нибудь для чтения или подтверждения?	
	foreach $client ( $select->can_read( 1 ) )
	{
		if ( $client == $server )
		{
			# Принять новое подключение
			$client = $server->accept();
			$select->add( $client );
		}		
		else
		{
			# Прочитать данные
			$data = '';
			$rv = $client->recv( $data, POSIX::BUFSIZ, 0 );

			unless( defined( $rv ) && length $data )
			{
				# Это должен быть конец файла, поэтому закрываем клиента
				delete $inbuffer{$client};
				delete $outbuffer{$client};
				delete $ready{$client};

				$select->remove( $client );
				close $client;
				next;
			}

			$inbuffer{$client} .= $data;

			# Проверить, говорят ли данные в буфере или только что прочитанные
			# данные о наличии полного запроса, ожидающего выполнения. Если да - 
			# заполнить $ready{$client} запросами, ожидающими обработки.
			while( $inbuffer{$client} =~ s/(.*\n)// ) { push( @{$ready{$client}}, $1 ) }
		}
	}
	
	# Есть ли полные запросы для обработки?
	foreach $client ( keys %ready ) { handle( $client ); }

	# Сбрасываем буферы?
	foreach $client ( $select->can_write( 1 ) )
	{
		# Пропустить этого слиента, если нам нечего сказать
		next unless $outbuffer{$client};

		$rv = $client->send( $outbuffer{$client}, 0 );
		unless( defined $rv )
		{
			# Пожаловаться, но следовать дальше
			warn "I was told I could write? but I can`t.\n";
			next;
		}
		if ( $rv == length $outbuffer{$client} || $! == POSIX::EWOULDBLOCK )
		{
			substr( $outbuffer{$client}, 0, $rv ) = '';
			delete $outbuffer{$client} unless length $outbuffer{$client};
		}
		else
		{
			# Не удалось записать все данные и не из-за блокировки.
			# Очистить буферы и следовать дальше.
			delete $inbuffer{$client};
			delete $outbuffer{$client};
			delete $ready{$client};

			$select->remove($client);
			close($client);
			next;
		}
	}
}

# handle( $socket ) обрабатывает все необработанные запросы
# для клиента $client
sub handle
{
	# Запрос находится в $ready{$client}
	# Отправить вывод в $outbuffer{$client}
	my $client = shift;
	my $request;

	foreach $request ( @{$ready{$client}} )
	{
		print "\nrequest=".$request if ( $debug == 1 );

		if ( $request =~ /^test/ )
		{
			my $open_client = "";
			foreach my $kod ( keys %CLRULE )
				{ $open_client .= $open_client eq "" ? $kod : " ".$kod; }
			$outbuffer{$client} .= $open_client."\n";
		}
		elsif ( $request =~ /^add\t([0-9]+)\t\|?(.*)/ )
		{
			my ($kod, $rule) = ($1, $2);
			&delete_rule( $kod ) if ( exists $CLRULE{$kod} );
			&add_rule( $kod, $rule ) if ( !exists $CLRULE{$kod} );
		}
		elsif ( $request =~ /^remove\t([0-9]+)/ )
		{
			&delete_rule( $1 ) if ( exists $CLRULE{$1} );
		}
		elsif ( $request =~ /^uptime/ )
		{
		  my $uptime = 1000;
		  my $end   = time;
		  $outbuffer{$client} .= ( $end - $start )."\n";                        
		}
	}

	delete $ready{$client};
}

# nonblock( $socket ) переводит сокет в неблокирующий режим
sub nonblock
{
	my $socket = shift;
	my $flags;

	$flags = fcntl( $socket, F_GETFL, 0 )
		or die "Can`t get flags for socket: $!\n";
	fcntl( $socket, F_SETFL, $flags | O_NONBLOCK )
		or die "Can`t make socket nonblocking: $!\n";
}

sub add_rule
{
	my $kod = $_[0];
	my $rule = $_[1];
	my %N = ();
	my %P = ();

	$CLRULE{$kod} = $rule;

	#while ( $rule =~ /\{N([0-9]+)\}/ )
	while ( $rule =~ /\{N([AB0-9]+)\}/ )	
	{
		my $n = $1;
		my $i = $rule_start - 1;
		my $j = 0;
		while( 1 )
		{
			while( 1 )
			{
				$i++;
				last if ( !exists $USERULEN{$i} );
			}
			$j++;
			last if ( $j == $n );
			last if ( $n == 0 );
		}
		$USERULEN{$i} = $kod;
		$N{$n} = $i;
		$rule =~ s/\{N$n\}/$N{$n}/g;
	}

	#while ( $rule =~ /\{P([0-9]+)\}/ )
	while ( $rule =~ /\{P([AB0-9]+)\}/ )
	{
		my $p = $1;
		my $i = $pipe_start - 1;
		my $j = 0;
		while( 1 )
		{
			while( 1 )
			{
				$i++;
				last if ( !exists $USEPIPEN{$i} );
			}
			$j++;
			last if ( $j == $p );
			last if ( $p == 0 );
		}
		$USEPIPEN{$i} = $kod;
		$P{$p} = $i;
		$rule =~ s/\{P$p\}/$P{$p}/g;
		
		
		print "\n";

	}

	foreach my $i ( keys %N ) { $CLUSERULEN{$kod} .= exists $CLUSERULEN{$kod} && $CLUSERULEN{$kod} ne "" ? " ".$N{$i} : $N{$i}; }
	foreach my $i ( keys %P ) { $CLUSEPIPEN{$kod} .= exists $CLUSEPIPEN{$kod} && $CLUSEPIPEN{$kod} ne "" ? " ".$P{$i} : $P{$i}; }
	
	
	#foreach my $i ( keys %USEPIPEN ) { print "i=$i;value=$USEPIPEN{$i}\n"; }


	$rule =~ s/\|/; $add_command/g;

	print "$add_command$rule\n" if ( $debug == 1 );
	$err = `$add_command$rule`;
}

sub delete_rule
{
	my $kod = $_[0];

	if ( exists $CLRULE{$kod} )
	{
		my @N = split( / /, $CLUSERULEN{$kod} );
		
		foreach my $i ( @N )
        {
            print "$rule_delete_comand$i\n" if ( $debug == 1 );
            $err = `$rule_delete_comand$i`;
            delete $USERULEN{$i};
        }

		my @P = split( / /, $CLUSEPIPEN{$kod} );

		foreach my $i ( @P )
        {

			foreach my $command ( @pipe_delete_comand )
			{
          	  print "$command$i\n" if ( $debug == 1 );
          	  $err = `$command$i`;
          	  delete $USEPIPEN{$i};
          	}  
        }

		delete $CLUSERULEN{$kod};
		delete $CLUSEPIPEN{$kod};
		delete $CLRULE{$kod};
	}
}
